
Object^Null {
	
	-New() = "bbObjectCtor"
	-Delete() = "bbObjectDtor"

	-toString:String() = "bbObjectToString"
	-compare:Int(other:Object) = "bbObjectCompare"
	-sendMessage:Object(message:Object, sender:object) = "bbObjectSendMessage"
	-clone:Object() = "bbObjectClone"
	
	-_reserved1_() = "bbObjectReserved"
	-_reserved2_() = "bbObjectReserved"
	
} = "bbObjectClass"

String^Object {
	
	MAX_LENGTH:Int = 32756
	
	.length:Int
	
	-toString:String() = "bbStringToString"
	-compare:Int(other:String) = "bbStringCompare"
	-clone:String() = "bbStringClone"
	
	NOT_FOUND:Int = -1
	
	-find:Int(sub:String, start_index:Int = 0) = "bbStringFind"
	-findLast:Int(sub:String, start_index:Int = 0) = "bbStringFindLast"
	-findAll:Int[](sub:String, start_index:Int = 0) = "bbStringFindAll"
	-findAny:Int(all_subs:String[], start_index:Int = 0) = "bbStringFindAny"
	
	SIDE_BOTH:Int  = 0
	SIDE_LEFT:Int  = -1
	SIDE_RIGHT:Int = 1
	
	-trim:String(side:Int = 0) = "bbStringTrim"
	-replace:String(sub:String, with:String) = "bbStringReplace"

	-toLower:String() = "bbStringToLower"
	-toUpper:String() = "bbStringToUpper"
	
	-toInt:Int() = "bbStringToInt"
	-toLong:Long() = "bbStringToLong"
	-toFloat:Float() = "bbStringToFloat"
	-toDouble:Double() = "bbStringToDouble"
	-toCString:Byte Ptr() = "bbStringToCString"
	-toWString:Short Ptr() = "bbStringToWString"

	+FromInt:String(num:Int) = "bbStringFromInt"
	+FromLong:String(num:Long) = "bbStringFromLong"
	+FromFloat:String(num:Float) = "bbStringFromFloat"
	+FromDouble:String(num:Double) = "bbStringFromDouble"
	+FromCString:String(c_str:Byte Ptr) = "bbStringFromCString"
	+FromWString:String(w_str:Short Ptr) = "bbStringFromWString"
	
	+FromBytes:String(bytes:Byte Ptr, size:Int) = "bbStringFromBytes"
	+FromShorts:String(shorts:Short Ptr, size:Int) = "bbStringFromShorts"

	-startsWith:Int(sub:String) = "bbStringStartsWith"
	-endsWith:Int(sub:String) = "bbStringEndsWith"
	-contains:Int(sub:String) = "bbStringContains"
	
	-split:String[](separator:String) = "bbStringSplit"
	-join:String(bits:String[]) = "bbStringJoin"
	
	+FromUTF8String:String(utf8_str:Byte Ptr) = "bbStringFromUTF8String"
	-ToUTF8String:Byte Ptr() = "bbStringToUTF8String"

	
	-equals:Int(rhs:String) = "bbStringEquals"
	-count:Int(sub:String) = "bbStringCount"
	-pad:String(length:Int, side:Int = 0) = "bbStringPad"
	-reverse:String() = "bbStringReverse"
	-rotate:String(count:Int) = "bbStringRotate"
	-times:String(count:Int) = "bbStringTimes"
	-sub:String(start_index:Int, length:Int) = "bbStringSub"
	
	-isLower:Int() = "bbStringIsLower"
	-isUpper:Int() = "bbStringIsUpper"
	-isASCII:Int() = "bbStringIsASCII"
	
}AF = "bbStringClass"

Array^Object {
	
	.elementTypeEncoding:Byte Ptr
	.numberOfDimensions:Int
	.sizeMinusHeader:Int
	.length:Int
	
	-toString:String() = "bbArrayToString"
	-compare:Int(other:Array) = "bbArrayCompare"
	-clone:Array() = "bbArrayClone"
	
	-sort(ascending:Int = 1) = "bbArraySort"
	-dimensions:Int[]() = "bbArrayDimensions"
	
	
	NOT_FOUND:Int = -1
	
	-find:Int(sub:Array, start_index:Int = 0) = "bbArrayFind"
	-findInt:Int(num:Int, start_index:Int = 0) = "bbArrayFindInt"
	-findLong:Int(num:Long, start_index:Int = 0) = "bbArrayFindLong"
	-findFloat:Int(num:Float, start_index:Int = 0) = "bbArrayFindFloat"
	-findDouble:Int(num:Double, start_index:Int = 0) = "bbArrayFindDouble"
	-findObject:Int(obj:Object, start_index:Int = 0) = "bbArrayFindObject"
	-findString:Int(str:String, start_index:Int = 0) = "bbArrayFindString"
	
	-startsWith:Int(other:Array) = "bbArrayStartsWith"
	-endsWith:Int(other:Array) = "bbArrayEndsWith"
	
	-contains:Int(sub:Array) = "bbArrayContains"
	-containsInt:Int(num:Int) = "bbArrayContainsInt"
	-containsLong:Int(num:Long) = "bbArrayContainsLong"
	-containsFloat:Int(num:Float) = "bbArrayContainsFloat"
	-containsDouble:Int(num:Double) = "bbArrayContainsDouble"
	-containsObject:Int(obj:Object) = "bbArrayContainsObject"
	-containsString:Int(str:String) = "bbArrayContainsString"
	
	-equals:Int(other:Array) = "bbArrayEquals"
	-reverse:Array() = "bbArrayReverse"
	-rotate:Array(count:Int = 1) = "bbArrayRotate"
	
}AF = "bbArrayClass"

TBaseException^Object {
	
	-clone:TBaseException() = "bbExceptionClone"
	
	-initCause(cause:TBaseException) = "bbExceptionInitCause"	
	-getCause:TBaseException() = "bbExceptionGetCause"
	
}A = "bbExceptionClass"
	
TBlitzException^TBaseException {
	
	-clone:TBlitzException() = "bbExceptionClone"
	
	-initCause(cause:TBaseException)F = "bbExceptionInitCause"	
	-getCause:TBaseException()F = "bbExceptionGetCause"
	
}A = "bbBlitzExceptionClass"
	
TNullMethodException^TBlitzException {
	
	-toString:String() = "bbNullMethodExceptionToString"
	-clone:TNullMethodException() = "bbExceptionClone"
	
	+Create:TNullMethodException() = "bbNullMethodExceptionCreate"
	
}F = "bbNullMethodExceptionClass"
	
TNullObjectException^TBlitzException {
	
	-toString:String() = "bbNullObjectExceptionToString"
	-clone:TNullObjectException() = "bbExceptionClone"
	
	+Create:TNullObjectException() = "bbNullObjectExceptionCreate"
	
}F = "bbNullObjectExceptionClass"

TNullFunctionException^TBlitzException {
	
	-toString:String() = "bbNullFunctionExceptionToString"
	-clone:TNullFunctionException() = "bbExceptionClone"
	
	+Create:TNullFunctionException() = "bbNullFunctionExceptionCreate"
	
}F = "bbNullFunctionExceptionClass"

TArrayBoundsException^TBlitzException {
	
	-toString:String()F = "bbArrayBoundsExceptionToString"
	-clone:TArrayBoundsException() = "bbExceptionClone"
	
	+Create:TArrayBoundsException() = "bbArrayBoundsExceptionCreate"
	
}F = "bbArrayBoundsExceptionClass"
	
TOutOfDataException^TBlitzException {
	
	-toString:String() = "bbOutOfDataExceptionToString"
	-clone:TOutOfDataException() = "bbExceptionClone"
	
	+Create:TOutOfDataException() = "bbOutOfDataExceptionCreate"
	
}F = "bbOutOfDataExceptionClass"

NullObjectError() = "brl_blitz_NullObjectError"
NullMethodError() = "brl_blitz_NullMethodError"
NullFunctionError() = "brl_blitz_NullFunctionError"
ArrayBoundsError() = "brl_blitz_ArrayBoundsError"
OutOfDataError() = "brl_blitz_OutOfDataError"

TRuntimeException^TBaseException {
	
	-toString:String() = "bbRuntimeExceptionToString"
	-clone:TRuntimeException() = "bbRuntimeExceptionClone"

	-initCause(cause:TBaseException)F = "bbExceptionInitCause"	
	-getCause:TBaseException()F = "bbExceptionGetCause"
	-getMessage:String()F = "bbRuntimeExceptionGetMessage"	
	
	+Create:TRuntimeException(message:String, cause:TBaseException = "bbNullObject") = "bbRuntimeExceptionCreate"
	
} = "bbRuntimeExceptionClass"

IEnumerator^Object {
	-hasNext:Int()A = "brl_blitz_NullMethodError"
	-nextObject:Object()A = "brl_blitz_NullMethodError"
}A = ""

IEnumerable^Object {
	-objectEnumerator:IEnumerator()A = "brl_blitz_NullMethodError"
}A = ""
	
GCEnter() = "bbGCEnter"
GCLeave() = "bbGCLeave"