#include "blitz_cclib.h"

BBInt bbIntAbs(BBInt x)
{
	return x >= 0 ? x : -x;
}

BBInt bbIntSgn(BBInt x)
{
	return x == 0 ? 0 : (x > 0 ? 1 : -1);
}

BBInt bbIntMod(BBInt x, BBInt y)
{
	return x % y;
}

BBInt bbIntMin(BBInt x, BBInt y)
{
	return x < y ? x : y;
}

BBInt bbIntMax(BBInt x, BBInt y)
{ 
	return x > y ? x : y;
}

void bbIntToLong(BBLong * const result, BBInt x)
{
	*result	= x;
}

BBDouble bbFloatAbs(BBDouble x)
{
	return fabs(x);
}

BBDouble bbFloatSgn(BBDouble x)
{
	return x == 0.0 ? 0.0 : (x > 0.0 ? 1.0 : -1.0);
}

BBDouble bbFloatPow(BBDouble x, BBDouble y)
{
	return pow(x, y);
}

BBDouble bbFloatMod(BBDouble x, BBDouble y)
{
	return fmod(x, y);
}

BBDouble bbFloatMin(BBDouble x, BBDouble y)
{
	return x < y ? x : y;
}

BBDouble bbFloatMax(BBDouble x, BBDouble y)
{
	return x > y ? x : y;
}

void bbFloatToLong(BBLong * const result, BBDouble x)
{
	*result	= x;
}

void bbLongNeg(BBLong * const result, BBLong x)
{
	*result	= -x;
}

void bbLongNot(BBLong * const result, BBLong x)
{
	*result	= ~x;
}

void bbLongAbs(BBLong * const result, BBLong x)
{
	*result	= (x >= 0 ? x : -x);
}

void bbLongSgn(BBLong * const result, BBLong x)
{
	*result	= (x > 0 ? 1 : (x < 0 ? -1 : 0));
}

void bbLongAdd(BBLong * const result, BBLong x, BBLong y)
{
	*result	= x + y;
}

void bbLongSub(BBLong * const result, BBLong x, BBLong y)
{
	*result	= x - y;
}

void bbLongMul(BBLong * const result, BBLong x, BBLong y)
{
	*result	= x * y;
}

void bbLongDiv(BBLong * const result, BBLong x, BBLong y)
{
	*result	= x / y;
}

void bbLongMod(BBLong * const result, BBLong x, BBLong y)
{
	*result	= x % y;
}

void bbLongMin(BBLong * const result, BBLong x, BBLong y)
{
	*result	= (x < y ? x : y);
}

void bbLongMax(BBLong * const result, BBLong x, BBLong y)
{
	*result	= (x > y ? x : y);
}

void bbLongAnd(BBLong * const result, BBLong x, BBLong y)
{
	*result	= x & y;
}

void bbLongOrl(BBLong * const result, BBLong x, BBLong y)
{
	*result	= x | y;
}

void bbLongXor(BBLong * const result, BBLong x, BBLong y)
{
	*result	= x ^ y;
}

void bbLongShl(BBLong * const result, BBLong x, BBLong y)
{
	*result	= x << y;
}

void bbLongShr(BBLong * const result, BBLong x, BBLong y)
{
	*result	= (BBUInt64)x >> (BBUInt64)y;
}

void bbLongSar(BBLong * const result, BBLong x, BBLong y)
{
	*result	= x >> y;
}

BBInt bbLongSlt(BBLong x, BBLong y)
{
	return x < y;
}

BBInt bbLongSgt(BBLong x, BBLong y)
{
	return x > y;
}

BBInt bbLongSle(BBLong x, BBLong y)
{
	return x <= y;
}

BBInt bbLongSge(BBLong x, BBLong y)
{
	return x >= y;
}

BBInt bbLongSeq(BBLong x, BBLong y)
{
	return x == y;
}

BBInt bbLongSne(BBLong x, BBLong y)
{
	return x != y;
}

BBDouble bbLongToFloat(BBLong x)
{
	return (BBDouble) x;
}
