/**
 * \file	blitz_unicode.h
 * \brief	UCS-2 character conversion tables
 *
 * \note	Currently BlitzMax does NOT support code points above the BMP.
 * \author	Mark Sibly
 */

#ifndef BLITZ_UNICODE_H
#define BLITZ_UNICODE_H

#include "_common.h"

BB_BEGIN_DECLS

/** \internal
 *
 * \brief	Contains data for upper to lower case character conversion.
 */
extern const BBChar bbToLowerData[1913];

/** \internal
 *
 * \brief	Contains data for lower to upper case character conversion.
 */
extern const BBChar bbToUpperData[1913];

BB_END_DECLS

#endif	// BLITZ_UNICODE_H
