#include "blitz_arrayboundsexception.h"

static void exception_ctor(BBArrayBoundsException *ex);

static const bb_debugscope_t ClassScope =
{
	.kind	= BBDEBUGSCOPE_USERTYPE,
	.name	= "TArrayBoundsException",
	.decls	=
	{
		[0] = {
			BBDEBUGDECL_TYPEFUNCTION,
			"Create", "():TArrayBoundsException",
			BBCLASS_VFN_OFFSETOF(2)
		},
		
		BBDEBUGDECL_END
	}
};

BBClass bbArrayBoundsExceptionClass =
{
	.super			= &bbBlitzExceptionClass,
	.free			= bbObjectFree,
	.debug_scope	= &ClassScope,
	.instance_size	= sizeof (BBArrayBoundsException),
	
	.ctor			= exception_ctor,
	.dtor			= bbExceptionDtor,
	
	.ToString		= bbArrayBoundsExceptionToString,
	.Compare		= bbExceptionCompare,
	.SendMessage	= bbObjectSendMessage,
	.Clone			= bbExceptionClone,
	
	.vfns =
	{
		[__BBEXCEPTION_VFN_INITCAUSE__]	= bbExceptionInitCause,	
		[__BBEXCEPTION_VFN_GETCAUSE__]	= bbExceptionGetCause,
		
		bbArrayBoundsExceptionCreate
	}
};

static const BBString Message =
{
	.clas	= &bbStringClass,
	.refs	= BBGC_MANYREFS,
	.length	= 50,
	.buf	= {
		'A','t','t','e','m','p','t',' ',
		't','o',' ','i','n','d','e','x',' ',
		'a','r','r','a','y',' ','e','l','e','m','e','n','t',' ',
		'b','e','y','o','n','d',' ','a','r','r','a','y',' ',
		'l','e','n','g','t','h'
	}
};

//	Built-in

void exception_ctor(BBArrayBoundsException *ex)
{
	ex->clas	= &bbArrayBoundsExceptionClass;
	ex->cause	= BBNULL;
}

BBString* bbArrayBoundsExceptionToString(const BBArrayBoundsException *ex)
{
#	ifdef BB_ENABLE_EXPERIMENTAL
	return &Message;
#	else
	return BBSTRING_FROMBUFFER(Message.buf, 50);
#	endif
}

//	API

BBArrayBoundsException* bbArrayBoundsExceptionCreate()
{
	BBArrayBoundsException *ex;
	
	ex			= BBBLITZEXCEPTION_ALLOC(&bbArrayBoundsExceptionClass);
	ex->cause	= BBNULL;
	
	return ex;
}

void brl_blitz_ArrayBoundsError()
{
	bbExThrow(bbArrayBoundsExceptionCreate());
}