/**
 * \file	blitz_arrayboundsexception.h
 * \brief	Exception concerning attempted access of array elements out of bounds
 *
 * \author	Fabian Niemann
 */

#ifndef BLITZ_ARRAYBOUNDSEXCEPTION_H
#define BLITZ_ARRAYBOUNDSEXCEPTION_H

#include "blitz_blitzexception.h"

BB_BEGIN_DECLS

/** Thrown in case of an attempt to accesss an array element that is out of bounds
 *
 * \extends	BBBlitzException
 */
struct BBArrayBoundsException
{
	BBClass			*clas;
	int				refs;
	
	BBException		*cause;
};

extern BBClass bbArrayBoundsExceptionClass;

/**
 *
 */
BBString* bbArrayBoundsExceptionToString(const BBArrayBoundsException *ex);

/**
 *
 */
BBArrayBoundsException* bbArrayBoundsExceptionCreate();

#define bbArrayBoundsError			brl_blitz_ArrayBoundsError

/** Throws a BBArrayBoundsError
 *
 */
void bbArrayBoundsError();

BB_END_DECLS

#endif	// BLITZ_ARRAYBOUNDSEXCEPTION_H
