#include "blitz_nullfunctionexception.h"

static void exception_ctor(BBNullFunctionException *ex);

static const bb_debugscope_t ClassScope =
{
	.kind	= BBDEBUGSCOPE_USERTYPE,
	.name	= "TNullFunctionException",
	.decls	=
	{
		[0] = {
			BBDEBUGDECL_TYPEFUNCTION,
			"Create", "():TNullFunctionException",
			BBCLASS_VFN_OFFSETOF(2)
		},
		
		BBDEBUGDECL_END
	}
};

BBClass bbNullFunctionExceptionClass =
{
	.super			= &bbBlitzExceptionClass,
	.free			= bbObjectFree,
	.debug_scope	= &ClassScope,
	.instance_size	= sizeof (BBNullFunctionException),
	
	.ctor			= exception_ctor,
	.dtor			= bbObjectDtor,
	
	.ToString		= bbNullFunctionExceptionToString,
	.Compare		= bbExceptionCompare,
	.SendMessage	= bbObjectSendMessage,
	.Clone			= bbExceptionClone,
	
	.vfns =
	{
		[__BBEXCEPTION_VFN_GETCAUSE__]	= bbExceptionGetCause,
		[__BBEXCEPTION_VFN_INITCAUSE__]	= bbExceptionInitCause,
		
		bbNullFunctionExceptionCreate
	}
};

static const BBString Message =
{
	.clas	= &bbStringClass,
	.refs	= BBGC_MANYREFS,
	.length	= 46,
	.buf	=
	{
		'A','t','t','e','m','p','t',' ',
		't','o',' ','c','a','l','l',' ',
		'u','n','i','n','i','t','i','a','l','i','z','e','d',' ',
		'f','u','n','c','t','i','o','n',' ',
		'p','o','i','n','t','e','r'
	}
};

void exception_ctor(BBNullFunctionException *ex)
{
	ex->clas	= &bbNullFunctionExceptionClass;
	ex->cause	= &bbNullObject;
}

BBString* bbNullFunctionExceptionToString(const BBNullFunctionException *ex)
{
#	ifdef BB_ENABLE_EXPERIMENTAL
	return &Message;
#	else
	return BBSTRING_FROMBUFFER(Message.buf, 46);
#	endif
}

BBNullFunctionException* bbNullFunctionExceptionCreate()
{
	BBNullFunctionException *ex;
	
	ex			= BBBLITZEXCEPTION_ALLOC(&bbNullFunctionExceptionClass);
	ex->cause	= BBNULL;
	
	return ex;
}

void brl_blitz_NullFunctionError()
{
	bbExThrow(bbNullFunctionExceptionCreate());
}