#include "blitz_nullmethodexception.h"

static void exception_ctor(BBNullMethodException *ex);

static const bb_debugscope_t ClassScope =
{
	.kind	= BBDEBUGSCOPE_USERTYPE,
	.name	= "TNullMethodException",
	.decls	=
	{
		[0] = {
			BBDEBUGDECL_TYPEFUNCTION,
			"Create", "():TNullMethodException",
			BBCLASS_VFN_OFFSETOF(2)
		},
		
		BBDEBUGDECL_END
	}
};

BBClass bbNullMethodExceptionClass =
{
	.super			= &bbBlitzExceptionClass,
	.free			= bbObjectFree,
	.debug_scope	= &ClassScope,
	.instance_size	= sizeof (BBNullMethodException),
	
	.ctor			= exception_ctor,
	.dtor			= bbExceptionDtor,
	
	.ToString		= bbNullMethodExceptionToString,
	.Compare		= bbExceptionCompare,
	.SendMessage	= bbObjectSendMessage,
	.Clone			= bbExceptionClone,
	
	.vfns =
	{
		[__BBEXCEPTION_VFN_INITCAUSE__]	= bbExceptionInitCause,	
		[__BBEXCEPTION_VFN_GETCAUSE__]	= bbExceptionGetCause,
		
		bbNullMethodExceptionCreate
	}
};

static const BBString Message =
{
	.clas	= &bbStringClass,
	.refs	= BBGC_MANYREFS,
	.length	= 31,
	.buf	= {
		'A','t','t','e','m','p','t',' ',
		't','o',' ','c','a','l','l',' ',
		'a','b','s','t','r','a','c','t',' ',
		'm','e','t','h','o','d'
	}
};

void exception_ctor(BBNullMethodException *ex)
{
	ex->clas	= &bbNullMethodExceptionClass;
	ex->cause	= BBNULL;
}

BBString* bbNullMethodExceptionToString(const BBNullMethodException *ex)
{
#	ifdef BB_ENABLE_EXPERIMENTAL
	return &Message;
#	else
	return BBSTRING_FROMBUFFER(Message.buf, 31);
#	endif
}

BBNullMethodException* bbNullMethodExceptionCreate()
{
	BBNullMethodException *ex;
	
	ex			= BBBLITZEXCEPTION_ALLOC(&bbNullMethodExceptionClass);
	ex->cause	= BBNULL;
	
	return ex;
}

void brl_blitz_NullMethodError()
{
	bbExThrow(bbNullMethodExceptionCreate());
}