/**
 * \file	blitz_nullmethodexception.h
 * \brief	Exception concerning calls of abstract methods
 *
 * \author	Fabian Niemann
 */

#ifndef BLITZ_EX_NULLMETHODEXCEPTION_H
#define BLITZ_EX_NULLMETHODEXCEPTION_H

#include "blitz_blitzexception.h"

BB_BEGIN_DECLS

/** Thrown in case of an attempt to call an abstract class method
 *
 * \extends	BBBlitzException
 */
struct BBNullMethodException
{
	BBClass			*clas;
	int				refs;
	
	BBException		*cause;
};

extern BBClass bbNullMethodExceptionClass;

/**
 *
 */
BBString* bbNullMethodExceptionToString(const BBNullMethodException *ex);

//	API

/** Creates a new NullMethod exception
 *
 */
BBNullMethodException* bbNullMethodExceptionCreate();

#define bbNullMethodError			brl_blitz_NullMethodError

/** Throws a BBNullMethodException
 *
 */
void bbNullMethodError();

BB_END_DECLS

#endif	// BLITZ_EX_NULLMETHODEXCEPTION_H
