#include "blitz_nullobjectexception.h"

static void exception_ctor(BBNullObjectException *ex);

static const bb_debugscope_t ClassScope =
{
	.kind	= BBDEBUGSCOPE_USERTYPE,
	.name	= "TNullObjectException",
	.decls	=
	{
		[0] = {
			BBDEBUGDECL_TYPEFUNCTION,
			"Create", "():TNullObjectException",
			BBCLASS_VFN_OFFSETOF(2)
		},
		
		BBDEBUGDECL_END
	}
};

BBClass bbNullObjectExceptionClass =
{
	.super			= &bbBlitzExceptionClass,
	.free			= bbObjectFree,
	.debug_scope	= &ClassScope,
	.instance_size	= sizeof (BBNullObjectException),
	
	.ctor			= exception_ctor,
	.dtor			= bbExceptionDtor,
	
	.ToString		= bbNullObjectExceptionToString,
	.Compare		= bbExceptionCompare,
	.SendMessage	= bbObjectSendMessage,
	.Clone			= bbExceptionClone,
	
	.vfns =
	{
		[__BBEXCEPTION_VFN_GETCAUSE__]	= bbExceptionGetCause,
		[__BBEXCEPTION_VFN_INITCAUSE__]	= bbExceptionInitCause,
		
		bbNullObjectExceptionCreate
	}
};

static const BBString Message =
{
	.clas	= &bbStringClass,
	.refs	= BBGC_MANYREFS,
	.length	= 48,
	.buf	= {
		'A','t','t','e','m','p','t',' ',
		't','o',' ','a','c','c','e','s','s',' ',
		'f','i','e','l','d',' ','o','r',' ',
		'm','e','t','h','o','d',' ','o','f',' ',
		'N','u','l','l',' ','o','b','j','e','c','t'
	}
};

void exception_ctor(BBNullObjectException *ex)
{
	ex->clas	= &bbNullObjectExceptionClass;
	ex->cause	= BBNULL;
}

BBString* bbNullObjectExceptionToString(const BBNullObjectException *ex)
{
#	ifdef BB_ENABLE_EXPERIMENTAL
	return &Message;
#	else
	return BBSTRING_FROMBUFFER(Message.buf, 48);
#	endif
}

BBNullObjectException* bbNullObjectExceptionCreate()
{
	BBNullObjectException *ex;
	
	ex			= BBBLITZEXCEPTION_ALLOC(&bbNullObjectExceptionClass);
	ex->cause	= BBNULL;
	
	return ex;
}

void brl_blitz_NullObjectError()
{
	bbExThrow(bbNullObjectExceptionCreate());
}