#include "blitz_outofdataexception.h"

static void exception_ctor(BBOutOfDataException *ex);

static const bb_debugscope_t ClassScope =
{
	.kind	= BBDEBUGSCOPE_USERTYPE,
	.name	= "TOutOfDataException",
	.decls	=
	{
		[0] = {
			BBDEBUGDECL_TYPEFUNCTION,
			"Create", "():TOutOfDataException",
			BBCLASS_VFN_OFFSETOF(2)
		},	
		
		BBDEBUGDECL_END
	}
};

BBClass bbOutOfDataExceptionClass =
{
	.super			= &bbBlitzExceptionClass,
	.free			= bbObjectFree,
	.debug_scope	= &ClassScope,
	.instance_size	= sizeof (BBOutOfDataException),
	
	.ctor			= exception_ctor,
	.dtor			= bbExceptionDtor,
	
	.ToString		= bbOutOfDataExceptionToString,
	.Compare		= bbExceptionCompare,
	.SendMessage	= bbObjectSendMessage,
	.Clone			= bbExceptionClone,
	
	.vfns = {
		[__BBEXCEPTION_VFN_GETCAUSE__]	= bbExceptionGetCause,
		[__BBEXCEPTION_VFN_INITCAUSE__]	= bbExceptionInitCause,
		
		bbOutOfDataExceptionCreate
	}
};

static const BBString Message =
{
	.clas	= &bbStringClass,
	.refs	= BBGC_MANYREFS,
	.length	= 34,
	.buf	= {
		'A','t','t','e','m','p','t',' ',
		't','o',' ','r','e','a','d',' ',
		'b','e','y','o','n','d',' ','e','n','d',' ',
		'o','f',' ','d','a','t','a'
	}
};

void exception_ctor(BBOutOfDataException *ex)
{
	ex->clas	= &bbOutOfDataExceptionClass;
	ex->cause	= BBNULL;
}

BBString* bbOutOfDataExceptionToString(const BBOutOfDataException *ex)
{
#	ifdef BB_ENABLE_EXPERIMENTAL
	return &Message;
#	else
	return BBSTRING_FROMBUFFER(Message.buf, 34);
#	endif
}

BBOutOfDataException* bbOutOfDataExceptionCreate()
{
	BBOutOfDataException *ex;
	
	ex			= BBBLITZEXCEPTION_ALLOC(&bbOutOfDataExceptionClass);
	ex->cause	= BBNULL;
	
	return ex;
}

void brl_blitz_OutOfDataError()
{
	bbExThrow(bbOutOfDataExceptionCreate());
}