/**
 * \file	blitz_outofdataexception.h
 * \brief	Exception concerning the invalid access of a data section
 *
 * \author	Fabian Niemann
 */

#ifndef BLITZ_OUTOFDATAEXCEPTION_H
#define BLITZ_OUTOFDATAEXCEPTION_H

#include "blitz_blitzexception.h"

BB_BEGIN_DECLS

/** Thrown in case of an attempt to read beyond the range of a data section
 *
 * \extends	BBBlitzException
 */
struct BBOutOfDataException
{
	BBClass			*clas;
	int				refs;
	
	BBException		*cause;
};

extern BBClass bbOutOfDataExceptionClass;

/** 
 *
 * \returns	"Attempt to read beyond end of data"
 */
BBString* bbOutOfDataExceptionToString(const BBOutOfDataException *ex);

//	API

/** Creates a new OutOfData exception
 *
 */
BBOutOfDataException* bbOutOfDataExceptionCreate();

#define bbOutOfDataError		brl_blitz_OutOfDataError

/** Throws a BBOutOfDataException
 *
 */
void bbOutOfDataError();

BB_END_DECLS

#endif	// BLITZ_OUTOFDATAEXCEPTION_H
