Rem
bbdoc:	Basic object type
End Rem
Type Object

	Rem
	bbdoc:	Gives a string reprentation of the object
	returns: A string desribing the object
	about:	The default implementation gives the object's memory address
	End Rem
	Method toString:String()
	End Method
	
	Rem
	bbdoc:	Compares two objects
	returns: <dl>
				<dt>&lt; 0</dt><dd>The object is smaller than the @other one</dd>
				<dt>0</dt><dd>Both objects can be considered equal</dd>
				<dt>&gt; 0</dt><dd>The object is larger than the @other one</dd>
			 </dl>
	about:	The default implementation simply compare the objects' memory addresses.
			Therefore it only returns <tt>0</tt> only when given the same instance.
	End Rem
	Method compare:Int(other:Object)
	End Method
	
	Rem
	bbdoc:	Sends a message to the object
	returns: The result that the message triggered
	about:	The default implentation does nothing and returns <tt>Null</tt>
	End Rem
	Method sendMessage:Object(sender:Object)
	End Method
	
	Rem
	bbdoc:	Clones the object
	returns: A new instance with the same values
	about:	The default implementation performs a shallow copy.
			That means all primitive data type properties (<tt>Field</tt>) are copied by value,
			but all object-like data type fields are copied only by reference.
	End Rem
	Method clone:Object()
	End Method

End Type
