Rem
bbdoc:	Basic exception type
End Rem
Type TBaseException Abstract
	
	Rem
	bbdoc:	Compares two exceptions for equal causes.
	returns:<dl>
				<dt>0</dt><dd>Both exceptions are equal</dd>
				<dt>-1</dt>
			</dl>
	End Rem
	Method compare:Int(other:TBaseException)
		
	End Method

	Rem
	bbdoc:	
	End Rem
	Method clone:TBaseException()
	
	End Method
	
	' A previously thrown exception that has caused this one to be thrown.
	' Not accessible from BlitzMax.
	Field cause:TBaseException
	
	Rem
	bbdoc:	Gets the exception that caused this one to be thrown.
	returns: The cause of this exception or Null if there is no known one.
	End Rem
	Method getCause:TBaseException() Final
		Return Self.cause
	End Method
	
	Rem
	bbdoc:	Initiliazes the cause of the exception
	about:	If the cause of the exception is not set, this will initialize it with
			the given exception object. Usually this is done in the Create function
			or right after creation.
			
			<p>You cannot initialize an exception with itself.</p>
	End Rem
	Method initCause(cause:TBaseException)
		
		If Not Self.cause And cause <> Self Then
			Self.cause = cause
		End If
		
	End Method
	
End Type
